package weaver.interfaces.newwaymask.cron;

import com.engine.newwaymask.entity.HrmResource;
import com.weaver.general.Util;
import weaver.conn.RecordSet;
import weaver.general.TimeUtil;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author liang.cheng
 * @Date 2025/4/1 11:22
 * @Description: 定时更新人员最新部门和岗位数据 分部 状态
 * @Version 1.0
 */
public class ResourceCardUpdateCron extends BaseCronJob {


    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        String currentDate = TimeUtil.getCurrentDateString();
        List<HrmResource> hrmResourceList = new ArrayList<>();
        rs.executeQuery("select a.rzry,a.fb,a.bm,a.gw,b.zt from uf_rzxxb a left join uf_gwztysgxb b\n" +
                "on a.gwzt = b.gwzt where a.rzlx = 0 and a.ksrq = ?",currentDate);

        while (rs.next()) {
            hrmResourceList.add(HrmResource.builder()
                    .id(Util.getIntValue(rs.getString("rzry")))
                    .subCompany(Util.getIntValue(rs.getString("fb")))
                    .department(Util.getIntValue(rs.getString("bm")))
                    .jobTitle(Util.getIntValue(rs.getString("gw")))
                    .status(Util.getIntValue(rs.getString("zt")))
                    .build());
        }

        String jobTitle = rs.getPropValue("newwaysecond", "jobTitle");

        hrmResourceList.forEach(item -> {
            //1.更新人员表
            rs.executeUpdate("update hrmResource set subcompanyid1 = ?,departmentid = ?,status = ? where id = ?",item.getSubCompany(),
                    item.getDepartment(),item.getStatus(),item.getId());

            //2.更新自定义表
            rs.executeUpdate("update cus_fielddata set "+jobTitle+" = ? where scope = 'HrmCustomFieldByInfoType' and scopeid = -1 and id = ?",item.getJobTitle(),item.getId());

        });


    }
}
